﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LOTO
{
    internal class Lotto
    {
        int[] matchCounts = new int[7];

        //Random array erzeuger
        public int[] RandomNumbers()
        {
            Random rn = new Random();
            bool dupl;
            int[] x = new int[6];

            for (int i = 0; i < 6; i++)
            {
                int y = rn.Next(1, 50);
                dupl = DuplicateChecker(x, y);

                while (dupl == true)
                {
                    y = rn.Next(1, 50);
                    dupl = DuplicateChecker(x, y);
                }

                x[i] = y;
            }

            return x;
        }

        //Prüft duplizierte Zahlen in einem array
        public bool DuplicateChecker(int[] x, int z)
        {
            for (int i = 0; i < x.Length; i++)
            {
                if (x[i] == z)
                {
                    return true;
                }
            }

            return false;
        }

        //recursiv binary search ,der prüft eine Zahl ,ob sie in einem Array liegt.
        public bool RevursivBinarySearch(int[] arry, int target, int left, int right)
        {
            int mid = (left + right) / 2;

            if (left > right)
            {
                return false;
            }

            if (arry[mid] == target)
            {
                return true;
            }
            else if (arry[mid] < target)
            {
                left = mid + 1;
                return RevursivBinarySearch(arry, target, left, right);
            }
            else
            {
                right = mid - 1;
                return RevursivBinarySearch(arry, target, left, right);
            }
        }

        //addiert die Zhal der arrays,der i matches haben
        public int[] Stats(int count)
        {
            if (count > 0) 
            {
                matchCounts[count]++;
            }
            return matchCounts;
        }

        //rechnet die Möglichkeit der Gewinn 
        public double Möglichkeit(int ticket)
        {
            //13983816 ist die Gesamtzahl der möglichen Kombinationen für Lotto 6/49 ( C(m,n) = m! / (n! × (m-n)!) )

            int m = 13983816;
            double möglichkeit = (double)ticket / m;

            return Math.Round(möglichkeit, 12);
        }
    }
}
